--- airo_mpi.c	2003-10-15 23:28:32.000000000 +0200
+++ airo_mpi-redhat.c	2003-10-16 12:03:10.000000000 +0200
@@ -3567,19 +3567,19 @@
 	
 	daemonize();
 	reparent_to_init();
-	spin_lock_irq(&current->sigmask_lock);
+	spin_lock_irq(&current->sighand->siglock);
 	sigemptyset(&current->blocked);
-	recalc_sigpending(current);
-	spin_unlock_irq(&current->sigmask_lock);
+	recalc_sigpending();
+	spin_unlock_irq(&current->sighand->siglock);
 
 	strncpy (current->comm, dev->name, sizeof(current->comm) - 1);
 	current->comm[sizeof(current->comm) - 1] = '\0';
 
 	while(1) {
 		if (signal_pending(current)) {
-			spin_lock_irq(&current->sigmask_lock);
+			spin_lock_irq(&current->sighand->siglock);
 			flush_signals(current);
-			spin_unlock_irq(&current->sigmask_lock);
+			spin_unlock_irq(&current->sighand->siglock);
 		}
 
 		if (test_bit(JOB_DIE, &ai->flags))