--- calltree-0.2.95.orig/src/ct_main.c	2003-04-15 00:41:53.000000000 +0200
+++ calltree-0.2.95/src/ct_main.c	2003-05-22 00:38:21.000000000 +0200
@@ -4612,6 +4612,7 @@
       /* TLB info, ignore */
       case 0x01: case 0x02: case 0x03: case 0x04:
       case 0x50: case 0x51: case 0x52: case 0x5b: case 0x5c: case 0x5d:
+      case 0xb0: case 0xb3:
           break;      
 
       case 0x06: *I1c = (cache_t) {  8, 4, 32 }; break;
@@ -4633,6 +4634,10 @@
              "warning: L3 cache detected but ignored\n");
           break;
 
+      /* Pentium M L1 cache specifications */
+      case 0x2c: *D1c = (cache_t) {  32, 8, 64 }; break;
+      case 0x30: *I1c = (cache_t) {  32, 8, 64 }; break;
+
       /* These are sectored, whatever that means */
       case 0x39: *L2c = (cache_t) {  128, 4, 64 }; L2_found = True; break;
       case 0x3c: *L2c = (cache_t) {  256, 4, 64 }; L2_found = True; break;
@@ -4685,6 +4690,8 @@
       case 0x83: *L2c = (cache_t) {  512, 8, 32 };  L2_found = True;  break;
       case 0x84: *L2c = (cache_t) { 1024, 8, 32 };  L2_found = True;  break;
       case 0x85: *L2c = (cache_t) { 2048, 8, 32 };  L2_found = True;  break;
+      case 0x86: *L2c = (cache_t) {  512, 4, 64 };  L2_found = True;  break;
+      case 0x87: *L2c = (cache_t) { 1024, 8, 64 };  L2_found = True;  break;
 
       default:
           VG_(message)(Vg_DebugMsg, 