--- linux-2.6.7.bak/drivers/acpi/sleep/poweroff.c	2004-06-16 07:20:04.000000000 +0200
+++ linux-2.6.7/drivers/acpi/sleep/poweroff.c	2004-06-17 19:44:49.000000000 +0200
@@ -9,11 +9,13 @@
 #include <linux/init.h>
 #include <acpi/acpi_bus.h>
 #include <linux/sched.h>
+#include <asm/apic.h>
 
 static void
 acpi_power_off (void)
 {
 	printk("%s called\n",__FUNCTION__);
+	disable_local_APIC ();
 	/* Some SMP machines only can poweroff in boot CPU */
 	set_cpus_allowed(current, cpumask_of_cpu(0));
 	acpi_enter_sleep_state_prep(ACPI_STATE_S5);