--- v2.4.21/arch/i386/kernel/i386_ksyms.c	2003-06-11 10:50:46.000000000 +0200
+++ linux/arch/i386/kernel/i386_ksyms.c	2003-06-07 18:02:08.000000000 +0200
@@ -55,6 +55,7 @@
 
 /* platform dependent support */
 EXPORT_SYMBOL(boot_cpu_data);
+EXPORT_SYMBOL(mmu_cr4_features);
 #ifdef CONFIG_EISA
 EXPORT_SYMBOL(EISA_bus);
 #endif