--- v2.4.21/arch/i386/kernel/setup.c	2003-06-11 10:50:46.000000000 +0200
+++ linux/arch/i386/kernel/setup.c	2003-06-11 10:45:50.000000000 +0200
@@ -2247,6 +2247,8 @@
 	{ 0x22, LVL_3,      512 },
 	{ 0x23, LVL_3,      1024 },
 	{ 0x25, LVL_3,      2048 },
+	{ 0x2C, LVL_1_DATA, 32 },
+	{ 0x30, LVL_1_INST, 32 },
 	{ 0x29, LVL_3,      4096 },
 	{ 0x39, LVL_2,      128 },
 	{ 0x3b, LVL_2,      128 },
@@ -2270,6 +2272,8 @@
 	{ 0x83, LVL_2,      512 },
 	{ 0x84, LVL_2,      1024 },
 	{ 0x85, LVL_2,      2048 },
+	{ 0x86, LVL_2,      512 },
+	{ 0x87, LVL_2,      1024 },
 	{ 0x00, 0, 0}
 };
 