--- linux-2.4.22-pre10-ac1/arch/i386/kernel/speedstep-centrino.c.orig	2003-08-02 11:50:19.000000000 +0200
+++ linux-2.4.22-pre10-ac1/arch/i386/kernel/speedstep-centrino.c	2003-08-02 14:08:43.000000000 +0200
@@ -315,8 +315,10 @@
 	struct cpuinfo_x86 *cpu = cpu_data;
 	const struct cpu_model *model;
 	unsigned l, h;
+	int dummy, ecx;
 
-	if (!cpu_has(cpu, X86_FEATURE_EST))
+	cpuid(1,&dummy,&dummy,&ecx,&dummy);
+	if (!(ecx & (1<<7)))
 		return -ENODEV;
 
 	/* Only Intel Pentium M stepping 5 for now - add new CPUs as